]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Source-Links gefixt.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j12"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 grub
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
292 lfsmake2 gzip
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
308 lfsmake2 texinfo
309 lfsmake2 udev
310 lfsmake2 util-linux
311 lfsmake2 vim
312 }
313
314 buildipfire() {
315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
316 export LOGFILE
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
322 ipfiremake linux-atm
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
326 ipfiremake linux SMP=1
327 ipfiremake ipp2p SMP=1
328 ipfiremake fcdsl SMP=1
329 ipfiremake fcdsl2 SMP=1
330 ipfiremake fcdslsl SMP=1
331 ipfiremake fcdslusb SMP=1
332 ipfiremake fcdslslusb SMP=1
333 ipfiremake fcpci SMP=1
334 # ipfiremake promise-sata-300-tx SMP=1
335 ipfiremake zaptel PASS=S
336 ipfiremake linux
337 ipfiremake ipp2p
338 ipfiremake fcdsl
339 ipfiremake fcdsl2
340 ipfiremake fcdslsl
341 ipfiremake fcdslusb
342 ipfiremake fcdslslusb
343 ipfiremake fcpci
344 # ipfiremake promise-sata-300-tx
345 ipfiremake zaptel
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
349 ipfiremake pam
350 ipfiremake openssl
351 ipfiremake python
352 ipfiremake libnet
353 ipfiremake libjpeg
354 ipfiremake libpng
355 ipfiremake libtiff
356 ipfiremake lcms
357 ipfiremake libmng
358 ipfiremake freetype
359 ipfiremake libart
360 ipfiremake gd
361 ipfiremake popt
362 ipfiremake pcre
363 ipfiremake slang
364 ipfiremake newt
365 ipfiremake libcap
366 ipfiremake pciutils
367 ipfiremake libxml2
368 ipfiremake BerkeleyDB
369 ipfiremake mysql
370 ipfiremake cyrus-sasl
371 ipfiremake openldap
372 ipfiremake apache2
373 ipfiremake php
374 ipfiremake apache2 PASS=C
375 ipfiremake arping
376 ipfiremake beep
377 ipfiremake bind
378 ipfiremake capi4k-utils
379 ipfiremake cdrtools
380 ipfiremake dnsmasq
381 ipfiremake dosfstools
382 ipfiremake reiserfsprogs
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
386 ipfiremake GD
387 ipfiremake gnupg
388 ipfiremake hdparm
389 ipfiremake ibod
390 ipfiremake initscripts
391 ipfiremake iptables
392 ipfiremake ipp2p IPT=1
393 ipfiremake ipac-ng
394 ipfiremake ipaddr
395 ipfiremake iptstate
396 ipfiremake iputils
397 ipfiremake l7-protocols
398 ipfiremake isapnptools
399 # ipfiremake isdn4k-utils # What about mISDN???
400 ipfiremake kudzu
401 ipfiremake logrotate
402 ipfiremake logwatch
403 ipfiremake mingetty
404 ipfiremake misc-progs
405 ipfiremake mtools
406 ipfiremake nano
407 ipfiremake nash
408 ipfiremake nasm
409 ipfiremake URI
410 ipfiremake HTML-Tagset
411 ipfiremake HTML-Parser
412 ipfiremake Compress-Zlib
413 ipfiremake Digest
414 ipfiremake Digest-SHA1
415 ipfiremake Digest-HMAC
416 ipfiremake libwww-perl
417 ipfiremake Net-DNS
418 ipfiremake Net-IPv4Addr
419 ipfiremake Net_SSLeay
420 ipfiremake IO-Stringy
421 ipfiremake Unix-Syslog
422 ipfiremake Mail-Tools
423 ipfiremake MIME-Tools
424 ipfiremake Net-Server
425 ipfiremake Convert-TNEF
426 ipfiremake Convert-UUlib
427 ipfiremake Archive-Tar
428 ipfiremake Archive-Zip
429 ipfiremake Text-Tabs+Wrap
430 ipfiremake Locale-Country
431 ipfiremake GeoIP
432 ipfiremake fwhits
433 ipfiremake noip_updater
434 ipfiremake ntp
435 ipfiremake oinkmaster
436 ipfiremake openssh
437 ipfiremake openswan
438 ipfiremake pptpclient
439 ipfiremake rrdtool
440 ipfiremake setserial
441 ipfiremake setup
442 ipfiremake snort
443 ipfiremake squid
444 ipfiremake squid-graph
445 ipfiremake squidguard
446 ipfiremake tcpdump
447 ipfiremake traceroute
448 ipfiremake vlan
449 ipfiremake wireless
450 ipfiremake libsafe
451 ipfiremake 3c5x9setup
452 ipfiremake pakfire
453 ipfiremake java
454 ipfiremake bootsplash
455 ipfiremake spandsp
456 ipfiremake lzo
457 ipfiremake openvpn
458 ipfiremake pkg-config
459 ipfiremake glib
460 ipfiremake pammysql
461 ipfiremake xinetd
462 ipfiremake ghostscript
463 ipfiremake cups
464 ipfiremake samba
465 ipfiremake sudo
466 ipfiremake mc
467 ipfiremake wget
468 ipfiremake wput
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
474 ipfiremake lynx
475 ipfiremake postfix
476 ipfiremake procmail
477 ipfiremake fetchmail
478 ipfiremake cyrusimap
479 ipfiremake webcyradm
480 ipfiremake mailx
481 ipfiremake clamav
482 ipfiremake razor
483 ipfiremake spamassassin
484 ipfiremake amavisd
485 ipfiremake stund
486 ipfiremake libpri
487 # ipfiremake bristuff
488 ipfiremake asterisk
489 ipfiremake mpg123
490 ipfiremake libmad
491 ipfiremake libogg
492 ipfiremake libvorbis
493 ipfiremake lame
494 ipfiremake xvid
495 ipfiremake mpeg2dec
496 ipfiremake ffmpeg
497 ipfiremake sox
498 ipfiremake gnump3d
499 ipfiremake videolan
500 ipfiremake applejuice
501 ipfiremake ocaml
502 ipfiremake mldonkey
503 ipfiremake ntop
504 ipfiremake rsync
505 ipfiremake tcpwrapper
506 ipfiremake portmap
507 ipfiremake nfs
508 ipfiremake nmap
509 ipfiremake mbmon
510 ipfiremake iftop
511 ipfiremake ncftp
512 ipfiremake cftp
513 ipfiremake etherwake
514 ipfiremake ethereal
515 ipfiremake tftp-hpa
516 ipfiremake iptraf
517 ipfiremake nagios
518 ipfiremake yasuc
519 }
520
521 buildinstaller() {
522 # Run installer scripts one by one
523 LOGFILE="$BASEDIR/log/_build.installer.log"
524 export LOGFILE
525 ipfiremake syslinux
526 ipfiremake memtest
527 installmake linux-libc-header
528 installmake binutils
529 ipfiremake uClibc PASS=1
530 ipfiremake gcc INST=1
531 installmake uClibc PASS=2
532 installmake gcc INST=2
533 installmake uClibc PASS=3
534 installmake busybox
535 installmake udev
536 installmake slang
537 installmake newt
538 installmake gettext
539 installmake kbd
540 installmake popt
541 installmake sysvinit
542 installmake misc-progs
543 installmake e2fsprogs
544 installmake reiserfsprogs
545 installmake sysfsutils
546 installmake util-linux
547 installmake pciutils
548 installmake kudzu
549 # installmake bootsplash
550 installmake installer
551 installmake initrd
552 }
553
554 buildpackages() {
555 LOGFILE="$BASEDIR/log/_build.packages.log"
556 export LOGFILE
557 echo "... see detailed log in _build.*.log files" >> $LOGFILE
558
559 installmake strip
560
561 # Generating list of packages used
562 echo -n "Generating packages list from logs" | tee -a $LOGFILE
563 rm -f $BASEDIR/doc/packages-list
564 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
565 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
566 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
567 fi
568 done
569 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
570 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
571 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
572 rm -f $BASEDIR/doc/packages-list
573 # packages-list.txt is ready to be displayed for wiki page
574 beautify message DONE
575
576 # Create images for install
577 ipfiremake cdrom
578 ipfiremake pxe
579 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
580
581 # ipfirepackages
582
583 # Cleanup
584 stdumount
585 rm -rf $BASEDIR/build/tmp/*
586
587 # Generating total list of files
588 echo "Generating files list from logs" | tee -a $LOGFILE
589 rm -f $BASEDIR/log/FILES
590 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
591 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
592 echo "##" >>$BASEDIR/log/FILES
593 echo "## `basename $i`" >>$BASEDIR/log/FILES
594 echo "##" >>$BASEDIR/log/FILES
595 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
596 fi
597 done
598 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
599 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
600
601 cd $PWD
602
603 }
604
605 ipfirepackages() {
606 if [ -d "$BASEDIR/packages" ]; then
607 for i in `ls $BASEDIR/packages`; do
608 touch $BASEDIR/build/install/packages/$i.empty
609 done
610 fi
611 # ipfiredist amavisd
612 ipfiredist applejuice
613 ipfiredist asterisk
614 ipfiredist clamav
615 ipfiredist cups
616 ipfiredist cyrusimap
617 ipfiredist fetchmail
618 ipfiredist ffmpeg
619 ipfiredist gnump3d
620 ipfiredist iptraf
621 ipfiredist java
622 ipfiredist lame
623 ipfiredist libmad
624 ipfiredist libogg
625 ipfiredist libvorbis
626 ipfiredist mailx
627 ipfiredist mldonkey
628 ipfiredist mpeg2dec
629 ipfiredist nagios
630 ipfiredist nfs
631 ipfiredist nmap
632 ipfiredist ntop
633 ipfiredist portmap
634 ipfiredist postfix
635 ipfiredist procmail
636 ipfiredist samba
637 ipfiredist sox
638 ipfiredist spamassassin
639 ipfiredist subversion
640 ipfiredist videolan
641 ipfiredist webcyradm
642 ipfiredist xvid
643 ipfiredist yasuc
644 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
645 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
646 rm -rf $BASEDIR/build/install/packages/*
647 }
648
649 # See what we're supposed to do
650 case "$1" in
651 build)
652 clear
653 BUILDMACHINE=`uname -m`
654 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
655 #only restore on a clean disk
656 if [ ! -f log/cleanup-toolchain-2-tools ]; then
657 if [ ! -n "$PACKAGE" ]; then
658 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
659 prepareenv
660 buildtoolchain
661 else
662 PACKAGENAME=${PACKAGE%.tar.gz}
663 beautify build_stage "Packaged toolchain compilation"
664 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
665 tar zxf $PACKAGE
666 prepareenv
667 else
668 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
669 fi
670 fi
671 else
672 echo -n "Using installed toolchain" | tee -a $LOGFILE
673 beautify message SKIP
674 prepareenv
675 fi
676
677 beautify build_start
678 beautify build_stage_start "Building base"
679 buildbase
680 beautify build_stage_end
681
682 beautify build_stage_start "Building IPFire"
683 buildipfire
684 beautify build_stage_end
685
686 # Setzen des IPFire Builds
687 if [ "$FIREBUILD" ]; then
688 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
689 else
690 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
691 fi
692
693 beautify build_stage_start "Building installer"
694 buildinstaller
695 beautify build_stage_end
696
697 beautify build_stage_start "Building packages"
698 buildpackages
699 beautify build_stage_end
700 beautify build_end
701 ;;
702 shell)
703 # enter a shell inside LFS chroot
704 # may be used to changed kernel settings
705 prepareenv
706 entershell
707 ;;
708 changelog)
709 echo -n "Loading new Changelog from SVN: "
710 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
711 beautify message DONE
712 ;;
713 clean)
714 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
715 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
716 $LOSETUP -d $i 2>/dev/null
717 done
718 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
719 umount $i
720 done
721 stdumount
722 for i in `seq 0 7`; do
723 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
724 umount /dev/loop${i} 2>/dev/null;
725 losetup -d /dev/loop${i} 2>/dev/null;
726 fi;
727 done
728 rm -rf $BASEDIR/build
729 rm -rf $BASEDIR/cdrom
730 rm -rf $BASEDIR/packages
731 rm -rf $BASEDIR/log
732 if [ -h /tools ]; then
733 rm -f /tools
734 fi
735 beautify message DONE
736 ;;
737 downloadsrc)
738 if [ ! -d $BASEDIR/cache ]; then
739 mkdir $BASEDIR/cache
740 fi
741 mkdir -p $BASEDIR/log
742 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
743 FINISHED=0
744 cd $BASEDIR/lfs
745 for c in `seq $MAX_RETRIES`; do
746 if (( FINISHED==1 )); then
747 break
748 fi
749 FINISHED=1
750 cd $BASEDIR/lfs
751 for i in *; do
752 if [ -f "$i" -a "$i" != "Config" ]; then
753 echo -ne "Loading $i"
754 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
755 if [ $? -ne 0 ]; then
756 beautify message FAIL
757 FINISHED=0
758 else
759 if [ $c -eq 1 ]; then
760 beautify message DONE
761 fi
762 fi
763 fi
764 done
765 done
766 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
767 ERROR=0
768 for i in *; do
769 if [ -f "$i" -a "$i" != "Config" ]; then
770 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
771 if [ $? -ne 0 ]; then
772 echo -ne "MD5 difference in lfs/$i"
773 beautify message FAIL
774 ERROR=1
775 fi
776 fi
777 done
778 if [ $ERROR -eq 0 ]; then
779 echo -ne "${BOLD}all files md5sum match${NORMAL}"
780 beautify message DONE
781 else
782 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
783 beautify message FAIL
784 fi
785 cd - >/dev/null 2>&1
786 ;;
787 toolchain)
788 clear
789 prepareenv
790 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
791 buildtoolchain
792 BUILDMACHINE=`uname -m`
793 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
794 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
795 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
796 build/{bin,etc,usr/bin,usr/local} \
797 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
798 log >> $LOGFILE
799 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
800 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
801 stdumount
802 ;;
803 gettoolchain)
804 BUILDMACHINE=`uname -m`
805 # arbitrary name to be updated in case of new toolchain package upload
806 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
807 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
808 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
809 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
810 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
811 cd $BASEDIR/cache/toolchains
812 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
813 if [ $? -ne 0 ]; then
814 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
815 else
816 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
817 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
818 else
819 exiterror "$PACKAGE.md5 did not match, check downloaded package"
820 fi
821 fi
822 else
823 echo "Toolchain is already downloaded. Exiting..."
824 fi
825 ;;
826 othersrc)
827 prepareenv
828 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
829 chroot $LFS /tools/bin/env -i HOME=/root \
830 TERM=$TERM PS1='\u:\w\$ ' \
831 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
832 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
833 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
834 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
835 if [ $? -eq "0" ]; then
836 beautify message DONE
837 else
838 beautify message FAIL
839 fi
840 stdumount
841 ;;
842 svn)
843 case "$2" in
844 update|up)
845 # clear
846 echo -ne "Loading the latest source files...\n"
847 if [ $3 ]; then
848 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
849 else
850 svn update | tee -a $PWD/log/_build.svn.update.log
851 fi
852 if [ $? -eq "0" ]; then
853 beautify message DONE
854 else
855 beautify message FAIL
856 exit 1
857 fi
858 echo -ne "Writing the svn-info to a file"
859 svn info > $PWD/svn_status
860 if [ $? -eq "0" ]; then
861 beautify message DONE
862 else
863 beautify message FAIL
864 exit 1
865 fi
866 chmod 755 $0
867 exit 0
868 ;;
869 commit|ci)
870 clear
871 if [ -f /usr/bin/mcedit ]; then
872 export EDITOR=/usr/bin/mcedit
873 fi
874 if [ -f /usr/bin/nano ]; then
875 export EDITOR=/usr/bin/nano
876 fi
877 echo -ne "Selecting editor $EDITOR..."
878 beautify message DONE
879 if [ -e /sbin/yast ]; then
880 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
881 $0 changelog
882 fi
883 fi
884 svn commit
885 $0 svn up
886 $0 uploadsrc
887 ;;
888 dist)
889 if [ $3 ]; then
890 SVN_REVISION=$3
891 fi
892 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
893 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
894 exit 0
895 fi
896 echo -en "REV $SVN_REVISION: Downloading..."
897 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
898 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
899 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
900 evaluate 1
901
902 echo -en "REV $SVN_REVISION: Compressing files..."
903 if [ -e ipfire-source/trunk/make.sh ]; then
904 chmod 755 ipfire-source/trunk/make.sh
905 fi
906 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
907 evaluate 1
908 echo -en "REV $SVN_REVISION: Cleaning up..."
909 rm ipfire-source/ -r
910 evaluate 1
911 ;;
912 diff|di)
913 echo -ne "Make a local diff to last svn revision"
914 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
915 evaluate 1
916 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
917 ;;
918 esac
919 ;;
920 uploadsrc)
921 PWD=`pwd`
922 cd $BASEDIR/cache/
923 echo -e "Uploading cache to ftp server:"
924 ncftpls -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT ftp://$IPFIRE_FTP_URL_INT$IPFIRE_FTP_PATH_INT/ > /var/tmp/ftplist
925 for i in *; do
926 if [ "$i" == "toolchains" ]; then continue; fi
927 grep -q $i /var/tmp/ftplist
928 if [ "$?" -ne "0" ]; then
929 echo -ne "$i"
930 ncftpput -bb -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT $IPFIRE_FTP_URL_INT $IPFIRE_FTP_PATH_INT/ $i >> $BASEDIR/log/_build.uploadsrc.log 2>&1
931 if [ "$?" -eq "0" ]; then
932 beautify message DONE
933 else
934 beautify message FAIL
935 fi
936 fi
937 done
938 rm -f /var/tmp/ftplist
939 UL_TIME_START=`date +'%s'`
940 ncftpbatch -d > /dev/null 2>&1
941 while ps acx | grep -q ncftpbatch
942 do
943 UL_TIME=$(expr `date +'%s'` - $UL_TIME_START)
944 echo -ne "\r ${UL_TIME}s : Upload is running..."
945 sleep 1
946 done
947 beautify message DONE
948 cd $PWD
949 exit 0
950 ;;
951 upload)
952 case "$2" in
953 iso)
954 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
955 cat <<EOF > .ftp-commands
956 mkdir $IPFIRE_FTP_PATH_EXT
957 ls -lah
958 quit
959 EOF
960 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
961 rm -f .ftp-commands
962 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
963 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso
964 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso.md5
965 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-source-r$SVN_REVISION.tar.gz
966 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ svn_status
967 if [ "$?" -eq "0" ]; then
968 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
969 else
970 echo -e "There was an error while uploading the iso to the ftp server."
971 exit 1
972 fi
973 if [ "$3" = "--with-sources-cd" ]; then
974 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-sources-cd-$VERSION.$MACHINE.iso
975 fi
976 ;;
977 paks)
978 cat <<EOF > .ftp-commands
979 mkdir $IPFIRE_FTP_PATH_PAK
980 ls -lah
981 quit
982 EOF
983 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
984 rm -f .ftp-commands
985 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
986 if [ "$?" -eq "0" ]; then
987 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
988 else
989 echo -e "There was an error while uploading the packages to the ftp server."
990 exit 1
991 fi
992 ;;
993 esac
994 ;;
995 batch)
996 if [ "$2" -eq "--background" ]; then
997 batch_script
998 exit $?
999 fi
1000 if [ `screen -ls | grep -q ipfire` ]; then
1001 echo "Build is already running, sorry!"
1002 exit 1
1003 else
1004 if [ "$2" = "--rebuild" ]; then
1005 export IPFIRE_REBUILD=1
1006 echo "REBUILD!"
1007 else
1008 export IPFIRE_REBUILD=0
1009 fi
1010 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1011 screen -dmS ipfire $0 batch --background
1012 evaluate 1
1013 exit 0
1014 fi
1015 ;;
1016 watch)
1017 watch_screen
1018 ;;
1019 pxe)
1020 case "$2" in
1021 start)
1022 start_tftpd
1023 ;;
1024 stop)
1025 stop_tftpd
1026 ;;
1027 reload|restart)
1028 reload_tftpd
1029 ;;
1030 esac
1031 exit 0
1032 ;;
1033 "")
1034 clear
1035 svn info
1036 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1037 do
1038 case $name in
1039 "IPFIRE: Downloadsrc")
1040 $0 downloadsrc
1041 ;;
1042 "IPFIRE: Build (silent)")
1043 $0 build-silent
1044 ;;
1045 "IPFIRE: Watch Build")
1046 $0 watch
1047 ;;
1048 "IPFIRE: Batch")
1049 $0 batch
1050 ;;
1051 "IPFIRE: Clean")
1052 $0 clean
1053 ;;
1054 "SVN: Update")
1055 $0 svn update
1056 ;;
1057 "Help")
1058 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1059 cat doc/make.sh-usage
1060 ;;
1061 "LOG: Tail")
1062 tail -f log/_*
1063 ;;
1064 "Exit")
1065 break
1066 ;;
1067 esac
1068 done
1069 ;;
1070 config)
1071 make_config
1072 ;;
1073 *)
1074 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1075 cat doc/make.sh-usage
1076 ;;
1077 esac